﻿Imports Microsoft.Build.Framework
Imports System.Collections

Namespace MsdnMag.Exchange.PushNotificationClient
    ''' <summary>
    ''' Provides a mock build engine implementation to allow calling MSBuild tasks from outside of MSBuild, like
    ''' in general applications or in unit tests.
    ''' </summary>
    Friend Class BuildEngine
        Implements IBuildEngine

#Region "IBuildEngine Members"

        Public Function BuildProjectFile(ByVal projectFileName As String, ByVal targetNames() As String, ByVal globalProperties As IDictionary, ByVal targetOutputs As IDictionary) As Boolean Implements IBuildEngine.BuildProjectFile

            Return True
        End Function

        Public ReadOnly Property ColumnNumberOfTaskNode() As Integer Implements IBuildEngine.ColumnNumberOfTaskNode
            Get
                Return 0
            End Get
        End Property

        Public ReadOnly Property ContinueOnError() As Boolean Implements IBuildEngine.ContinueOnError
            Get
                Return True
            End Get
        End Property

        Public ReadOnly Property LineNumberOfTaskNode() As Integer Implements IBuildEngine.LineNumberOfTaskNode
            Get
                Return 0
            End Get
        End Property

        Public Sub LogCustomEvent(ByVal e As CustomBuildEventArgs) Implements IBuildEngine.LogCustomEvent
        End Sub

        Public Sub LogErrorEvent(ByVal e As BuildErrorEventArgs) Implements IBuildEngine.LogErrorEvent
            PushNotificationClient.WriteEventToLog(String.Format("[ERROR]: {0}", e.Message))
        End Sub

        Public Sub LogMessageEvent(ByVal e As BuildMessageEventArgs) Implements IBuildEngine.LogMessageEvent
            PushNotificationClient.WriteEventToLog(String.Format("[INFO]: {0}", e.Message))
        End Sub

        Public Sub LogWarningEvent(ByVal e As BuildWarningEventArgs) Implements IBuildEngine.LogWarningEvent
            PushNotificationClient.WriteEventToLog(String.Format("[WARNING]: {0}", e.Message))
        End Sub

        Public ReadOnly Property ProjectFileOfTaskNode() As String Implements IBuildEngine.ProjectFileOfTaskNode
            Get
                Return String.Empty
            End Get
        End Property

#End Region
    End Class
End Namespace
