﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Configuration
Imports System.Security.Principal
Imports System.Web.Services
Imports System.Xml.Serialization
Imports System.IO
Imports Timers = System.Timers
Imports Microsoft.Exchange.WebServices.Data
Imports Microsoft.TeamFoundation.Client
Imports PushSubscriber = MsdnMag.Exchange.PushNotificationSubscriber
Imports System.Web.Services.Protocols
Imports System.Linq
Imports Threading = System.Threading
Imports Microsoft.TeamFoundation.WorkItemTracking.Client
Imports System.Web

Namespace MsdnMag.Exchange.PushNotificationClient
    <WebService(Namespace:="http://www.contoso.com/Email2Workitem/2011")>
    Public Class PushNotificationClient
        Inherits WebService
        Implements INotificationServiceBinding

#Region "Constants"

        Private Const ERROR_EVENT_TEMPLATE As String = "{0} {1} - Error text: {2}"
        Private Const NOTIFICATION_EVENT_TEMPLATE As String = "{0} {1} - Event name: {2} [{3}]"
        Private Const UNSUBSCRIBE_EVENT_TEMPLATE As String = "{0} {1} - Event name: Unsubscribe"
        Private Const CHECKSTATUS_EVENT_TEMPLATE As String = "{0} {1} - Event name: Check Status"
        Private Const SUBSCRIPTION_TIMEOUT_TEMPLATE As String = "{0} {1} - Event name: Set Subscription Timeout: {2} milliseconds"
        Private Const SUBSCRIPTION_RENEWAL_TEMPLATE As String = "{0} {1} - Event name: Subscription Renewed after {2} minutes of inactivity. New Subscription Id: {3}"
        Private Const EMPTY_URL_ERROR_MESSAGE As String = "The URL was empty."
        Private Const LOCALHOST_HOST_ERROR_MESSAGE As String = "The host name specified in the URL is 'localhost'. A real host name is required for a subscription." & vbCrLf & "Suggested URL: {0}."
        Private Const EMPTY_SUBSCRIPTIONID_ERROR_MESSAGE As String = "SubscriptionId was empty."
        Private Const SOAP_EXCEPTION_TEMPLATE As String = "Execution failed." & vbCrLf & "Message: {0}"
        Private Const NEW_EMAIL_SKIPPED_TEMPLATE As String = "New email skipped since it was not the first email in conversation (sender: {0} - ConversationTopic ({1}): {2})"
        Private Const NEW_EMAIL_FROM_EXISTING_THREAD_TEMPLATE As String = "Creating new email from existing an thread since the first email in conversation has no work item (sender: {0} - ConversationTopic ({1}): {2})"
        Private Const ALREADY_ASSIGNED_EMAIL_SKIPPED_TEMPLATE As String = "Email skipped since it has already been assigned (sender: {0} - ConversationTopic ({1}): {2})"
        Private Const WORKITEM_BODY_TEMPLATE As String = "The following request was created from a new email message.<br/>" & vbCrLf & "<br/>" & vbCrLf & "<hr/>" & vbCrLf & "<table border='1' cellspacing='2' cellpadding='2' width='100%'>" & "<tr><td style='background-color:{8}'>" & vbCrLf & "<font color=green><b>Sender:</b></font> {0} ({1})<br/>" & vbCrLf & "<font color=green><b>Sent:</b></font> {2}<br/>" & vbCrLf & "<font color=green><b>Subject:</b></font> {3}" & vbCrLf & "</td></tr><tr><td>" & vbCrLf & "{4}" & "</td></tr></table>" & "<br/>" & vbCrLf & "<br/>" & vbCrLf & "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~<br/>" & vbCrLf & "Conversation Topic: {5}<br/>" & vbCrLf & "Conversation Index ({6}): {7}"
        Private Const WORKITEM_PARTIAL_BODY_TEMPLATE As String = "<table border='1' cellspacing='2' cellpadding='2' width='100%'>" & "<tr><td style='background-color:{4}'>" & vbCrLf & "<font color=green><b>Sender:</b></font> {0} ({1})<br/>" & vbCrLf & "<font color=green><b>Sent:</b></font> {2}" & vbCrLf & "</td></tr><tr><td>" & vbCrLf & "{3}" & "</td></tr></table>"
        Private Const TFS_APPLICATIONNAME_TEMPLATE As String = "MsdnMagSubscribeSvc [{0}]"
        Private Const WORKITEM_FIELDS_TEMPLATE As String = "MsdnMag.SupportTicket.UniqueIdentifier={0};MsdnMag.SupportTicket.RequesterName={1};" & "MsdnMag.SupportTicket.ConversationTopic={2};MsdnMag.SupportTicket.ConversationIndex={3};System.Description={4};" & "MsdnMag.SupportTicket.LatestConversationIndex={5};MsdnMag.SupportTicket.RequestSupportTeam={6}"
        Private Const WORKITEM_DESCRIPTION_TEMPLATE As String = "A request work item was created from a new email message." & vbCrLf & "Please navigate to the History tab to view the email details."
        Private Const UPDATE_WORKITEM_FIELDS_TEMPLATE As String = "MsdnMag.SupportTicket.LatestConversationIndex={0}"
        Private Const NEW_WORKITEM_CREATED_TEMPLATE As String = "New email written to work item {0} (sender: {1})"
        Private Const WORKITEM_UPDATED_TEMPLATE As String = "Work item updated. Id: {0}. New Conversation Index: {1}."
        Private Const EMAIL_TO_WORKITEM_ERROR_TEMPLATE As String = "Error (email-2-workitem): {0}" & vbCrLf & "--> StackTrace:" & vbCrLf & "{1}"
        Private Const SUBSCRIPTION_RENEWAL_ERROR_TEMPLATE As String = "Error (subscription renewal): {0}" & vbCrLf & "--> StackTrace:" & vbCrLf & "{1}"
        Private Const TIMER_ERROR_TEMPLATE As String = "Error (PollingTimer): {0}" & vbCrLf & "--> StackTrace:" & vbCrLf & "{1}"
        Private Const EMAIL_ALREADY_CONVERTED_TO_WORKITEM_TEMPLATE As String = "Found email already converted to work item. Work Item: {0}. Email Internet Message Id: {1}."
        Private Const SUBJECT_DOES_NOT_MATCH_PREFIX_TEMPLATE As String = "Email skipped since subject does not match defined prefix. Prefix='{0}'. Subject='{1}'."
        Private Const UPDATEWORKITEM_ERROR_TEMPLATE As String = "Error (update work item): {0}" & vbCrLf & "--> StackTrace:" & vbCrLf & "{1}"
        Private Const NOTIFICATION_EVENTS_LOG_TEMPLATE As String = "{0}SubscriberEventLog.txt"
        Private Const NOTIFICATION_RESPONSE_MESSAGES_LOG_TEMPLATE As String = "{0}{1}-{2}.xml"
        Private Const STATUS_TEMPLATE As String = "LastStatusEventDateTime: {0}." & " PollingIntervalInMilliseconds: {1}." & " Status: {2}."
        Private Const QUERY_BY_CONVERSATION_INDEX_WIQL As String = "SELECT [System.Id] FROM WorkItems WHERE [System.TeamProject] = '{0}'  AND  [System.WorkItemType] = 'Support Request' AND [MsdnMag.SupportTicket.ConversationIndex] = '{1}' ORDER BY [System.Id] desc"
        Private Const QUERY_BY_UNIQUE_IDENTIFIER_WIQL As String = "SELECT [System.Id] FROM WorkItems WHERE [System.TeamProject] = '{0}'  AND  [System.WorkItemType] = 'Support Request' AND [MsdnMag.SupportTicket.UniqueIdentifier] = '{1}' ORDER BY [System.Id] desc"

#End Region

#Region "Private Fields"

        Private Shared _syncLock As New Object()
        Private Shared _pollingTimerSyncLock As New Object()

        ' Set the working timer for polling
        Private Shared _pollingTimer As Threading.Timer
        Private Shared _lastStatusEventDateTime As Date = Date.MinValue

        ' Unsubscribe timer
        Private Shared _timer As Timers.Timer
        ' Unsubscribe flag
        Private Shared _unsubscribe As Boolean

        ' Static initialization (lazy initialization until first access)
        Private Shared _baseLogFolder As String = BaseLogFolder

        Private Shared _pollingIntervalInMilliseconds As Integer = Convert.ToInt32(ConfigurationManager.AppSettings("AutoSubscribePollingIntervalInMinutes")) * 60 * 1000 ' Every 1 minute.

#End Region

#Region "Properties"

        Private Shared ReadOnly Property BaseLogFolder() As String
            Get

                Dim _baseLogFolder As String = (If(String.IsNullOrWhiteSpace(ConfigurationManager.AppSettings("BaseLogsFolder")), String.Empty, String.Format("{0}{1}", ConfigurationManager.AppSettings("BaseLogsFolder"), (If(ConfigurationManager.AppSettings("BaseLogsFolder").EndsWith("\"), String.Empty, "\")))))

                If _baseLogFolder.Length = 0 Then
                    Return _baseLogFolder
                End If

                Dim absolutePath As String
                ' If the path is relative, calculate absolute path and return it.
                If Not Path.IsPathRooted(_baseLogFolder) Then
                    Dim combinedPath As String = Path.Combine(HttpRuntime.AppDomainAppPath, _baseLogFolder)
                    absolutePath = Path.GetFullPath(combinedPath)
                Else ' path is already absolute.
                    absolutePath = _baseLogFolder
                End If

                If Not Directory.Exists(absolutePath) Then
                    Directory.CreateDirectory(absolutePath)
                End If

                Return absolutePath
            End Get
        End Property

        Private Shared ReadOnly Property TfsClientCacheDirectory() As String
            Get
                Dim _tfsClientCacheDirectory As String = ConfigurationManager.AppSettings("TfsClientCacheDirectory")

                If String.IsNullOrWhiteSpace(_tfsClientCacheDirectory) Then
                    Return String.Empty
                End If

                ' If the path is relative, calculate absolute path and return it.
                If Not Path.IsPathRooted(_tfsClientCacheDirectory) Then
                    Dim combinedPath As String = Path.Combine(HttpRuntime.AppDomainAppPath, _tfsClientCacheDirectory)
                    Return Path.GetFullPath(combinedPath)
                Else ' path is already absolute.
                    Return _tfsClientCacheDirectory
                End If
            End Get
        End Property

#End Region

#Region "Constructor"

        Public Sub New()
            InitializeTimer()
        End Sub

#End Region

#Region "Private Methods"

        Private Sub InitializeTimer()
            Dim autoSubscribeTimeoutThresholdInMinutes As Integer = Convert.ToInt32(ConfigurationManager.AppSettings("AutoSubscribeTimeoutThresholdInMinutes"))

            SyncLock _pollingTimerSyncLock
                If autoSubscribeTimeoutThresholdInMinutes > 0 Then
                    ' Seed the timer with the polling interval specified in config.
                    If _pollingTimer Is Nothing Then
                        Dim timerCallback As Threading.TimerCallback = AddressOf OnTimedEvent
                        _pollingTimer = New Threading.Timer(timerCallback, Nothing, 0, _pollingIntervalInMilliseconds) ' Enable the timer.
                    End If
                Else
                    ' Dispose of the timer.
                    If _pollingTimer IsNot Nothing Then
                        _pollingTimer.Dispose()
                        _pollingTimer = Nothing
                    End If
                End If
            End SyncLock
        End Sub

#End Region

#Region "INotificationServiceBinding Members"

        Public Function SendNotification(ByVal _sendNotification As SendNotificationResponseType) As SendNotificationResultType Implements INotificationServiceBinding.SendNotification
            SyncLock _pollingTimerSyncLock
                _lastStatusEventDateTime = Date.Now
            End SyncLock

            Dim timestamp As String = PushSubscriber.PushNotificationSubscriber.GetTimestamp()

            ' Create the response to the push notification.
            Dim result As New SendNotificationResultType()

            ' Get the push notifications.
            Dim rmta() As ResponseMessageType = _sendNotification.ResponseMessages.Items

            For Each rmt In rmta
                If rmt.ResponseCode <> ResponseCodeType.NoError Then
                    ' Log the error text.
                    WriteEventToLog(String.Format(ERROR_EVENT_TEMPLATE, Date.Now.ToShortDateString(), Date.Now.ToLongTimeString(), rmt.MessageText))

                    ' Discontinue the subscription if there is an error.
                    result.SubscriptionStatus = SubscriptionStatusType.Unsubscribe
                    Return result
                End If

                ' Cast to the correct response message type.
                Dim snrmt As SendNotificationResponseMessageType = TryCast(rmt, SendNotificationResponseMessageType)

                If rmt.ResponseCode <> ResponseCodeType.NoError OrElse (rmt.ResponseCode = ResponseCodeType.NoError AndAlso Convert.ToBoolean(ConfigurationManager.AppSettings("LogStatusEventResponse").ToLowerInvariant()) = True) Then
                    ' Write the XML content of the push notification.
                    CreateXmlMessageTextFile(snrmt, timestamp)
                End If

                ' Get the notification.
                Dim notification As NotificationType = snrmt.Notification

                ' Get the subscription identifier.
                Dim subscriptionId As String = notification.SubscriptionId

                ' Get the previous watermark for the subscription.
                Dim previousWatermark As String = notification.PreviousWatermark

                ' Indicate if an event has occured.
                Dim eventOccured As Boolean = False

                ' Handle each notification in the order in which the events occured.
                For c = 0 To notification.Items.Length - 1
                    ' Get the event name.
                    WriteEventToLog(String.Format(NOTIFICATION_EVENT_TEMPLATE, Date.Now.ToShortDateString(), Date.Now.ToLongTimeString(), notification.ItemsElementName(c).ToString(), subscriptionId))

                    Dim bnet() As BaseNotificationEventType = notification.Items

                    ' Access information about copy or move events.
                    If TypeOf bnet(c) Is MovedCopiedEventType Then
                        AccessMovedCopiedEvent(TryCast(bnet(c), MovedCopiedEventType))
                        eventOccured = True

                        SyncLock _syncLock
                            ' Close the _timer.
                            If _timer IsNot Nothing Then
                                _timer.Close()
                            End If
                        End SyncLock

                        ' Access information about create, delete, or new mail events.
                    ElseIf TypeOf bnet(c) Is BaseObjectChangedEventType Then
                        AccessCreateDeleteNewMailEvent(TryCast(bnet(c), BaseObjectChangedEventType))
                        eventOccured = True

                        SyncLock _syncLock
                            ' Close the _timer.
                            If _timer IsNot Nothing Then
                                _timer.Close()
                            End If
                        End SyncLock

                        ' Access information about modified events.
                    ElseIf TypeOf bnet(c) Is ModifiedEventType Then
                        AccessModifiedEvent(TryCast(bnet(c), ModifiedEventType))
                        eventOccured = True

                        SyncLock _syncLock
                            ' Close the _timer.
                            If _timer IsNot Nothing Then
                                _timer.Close()
                            End If
                        End SyncLock

                        ' No events have occured.
                    Else
                        Dim unsubscribeOnIdleTimeoutInMilliseconds As Double = Convert.ToDouble(ConfigurationManager.AppSettings("UnsubscribeOnIdleTimeoutInMilliseconds"))
                        Dim isUnsubscribeOnIdle As Boolean = Convert.ToBoolean(ConfigurationManager.AppSettings("UnsubscribeOnIdle"))
                        If (Not eventOccured) AndAlso isUnsubscribeOnIdle Then
                            WriteEventToLog(String.Format(SUBSCRIPTION_TIMEOUT_TEMPLATE, Date.Now.ToShortDateString(), Date.Now.ToLongTimeString(), unsubscribeOnIdleTimeoutInMilliseconds))

                            SyncLock _syncLock
                                ' Set _timer to n minutes (web.config). If no events have occured in n minutes, then set _unsubscribe flag.
                                _timer = New Timers.Timer(unsubscribeOnIdleTimeoutInMilliseconds)
                                AddHandler _timer.Elapsed, AddressOf timer_Elapsed
                                _timer.Enabled = True
                            End SyncLock

                        Else
                            eventOccured = False
                        End If

                    End If
                Next c

                ' If there are more events ready to be sent, then continue the subscription.
                If notification.MoreEvents Then
                    result.SubscriptionStatus = SubscriptionStatusType.OK
                    Return result
                End If
            Next rmt

            Dim unsubscribe As Boolean = _unsubscribe
            If unsubscribe Then
                WriteEventToLog(String.Format(UNSUBSCRIBE_EVENT_TEMPLATE, Date.Now.ToShortDateString(), Date.Now.ToLongTimeString()))

                result.SubscriptionStatus = SubscriptionStatusType.Unsubscribe
                Return result

            Else
                result.SubscriptionStatus = SubscriptionStatusType.OK
                Return result
            End If
        End Function

#End Region

#Region "Web Methods"

        ''' <summary>
        ''' Checks the status of the web service and makes sure that all configured values are fine.
        ''' </summary>
        ''' <returns>A string describing the status of the web service.</returns>
        <WebMethod(Description:="Checks the status of the web service and makes sure that all configured values are fine.")>
        Public Function CheckStatus() As String
            Dim lastUpdateDateTime As String = If(_lastStatusEventDateTime = Date.MinValue, "-", String.Format("{0} {1}", _lastStatusEventDateTime.ToShortDateString(), _lastStatusEventDateTime.ToLongTimeString()))

            Dim seedValueInMilliseconds As Integer = 60000
            Dim status As String = If(_lastStatusEventDateTime = Date.MinValue, "Not subscribed", If(_lastStatusEventDateTime.AddMilliseconds(_pollingIntervalInMilliseconds + seedValueInMilliseconds).CompareTo(Date.Now) >= 0, "Subscribed", "Not Subscribed"))

            Dim statusMessage As String = String.Format(STATUS_TEMPLATE, lastUpdateDateTime, _pollingIntervalInMilliseconds, status)

            WriteEventToLog(String.Format(CHECKSTATUS_EVENT_TEMPLATE, Date.Now.ToShortDateString(), Date.Now.ToLongTimeString()))

            Return statusMessage
        End Function

        ''' <summary>
        ''' Creates a push notification subscription for new email messages for the current web service's App Pool identity.
        ''' The subscription is registered against the current web service's URL.
        ''' </summary>
        ''' <returns>A string representing the Subscription Id for a successful subscription.</returns>
        <WebMethod(Description:="Creates a push notification subscription for new email messages for the current web service's App Pool identity. " & "The subscription is registered against the current web service's URL. Do not call this method if the host name in the URL is 'localhost'. " & "Make sure it is the actual host name or the DNS name.")>
        Public Function Subscribe() As String
            Try
                Dim url As String = (If(Context.Request.Url.AbsoluteUri.ToString(), String.Empty)).Replace("/Subscribe", String.Empty)
                If String.IsNullOrWhiteSpace(url) Then
                    Throw New Exception(EMPTY_URL_ERROR_MESSAGE)
                End If

                If String.Compare(Context.Request.Url.Host, "localhost", ignoreCase:=True) = 0 Then
                    Dim hostName As String = Context.Server.MachineName
                    Dim errorMessage As String = String.Format(LOCALHOST_HOST_ERROR_MESSAGE, url.Replace("://localhost", "://" & hostName))

                    Throw New Exception(errorMessage)
                End If

                Dim pushNotificationSubscriber As New PushSubscriber.PushNotificationSubscriber()
                pushNotificationSubscriber.BaseLogFolder = _baseLogFolder
                pushNotificationSubscriber.EwsServiceUrl = ConfigurationManager.AppSettings("EWSServiceUrl")
                pushNotificationSubscriber.PushClientWebServiceUrl = url
                pushNotificationSubscriber.UseCurrentlyLoggedInUserCredentials = True
                pushNotificationSubscriber.UseAutodiscoveryForSubscribing = Convert.ToBoolean(ConfigurationManager.AppSettings("UseAutodiscoveryForSubscribing"))
                pushNotificationSubscriber.AutoDiscoveryEmail = ConfigurationManager.AppSettings("AutoDiscoveryEmail")
                pushNotificationSubscriber.PushNotificationsFrequencyInMinutes = Convert.ToInt32(ConfigurationManager.AppSettings("PushNotificationsFrequencyInMinutes"))
                pushNotificationSubscriber.SubscribeForPushNotifications()

                Dim subscriptionId As String = pushNotificationSubscriber.SubscriptionId
                If String.IsNullOrWhiteSpace(subscriptionId) Then
                    Throw New Exception(EMPTY_SUBSCRIPTIONID_ERROR_MESSAGE)
                End If

                ' Reset the status time to avoid registring multiple redudant subscriptions.
                SyncLock _pollingTimerSyncLock
                    _lastStatusEventDateTime = Date.Now
                End SyncLock

                Return subscriptionId
            Catch ex As Exception
                Throw New SoapException(String.Format(SOAP_EXCEPTION_TEMPLATE, ex.Message), SoapException.ClientFaultCode, ex)
            End Try
        End Function

#End Region

#Region "Timer Callback"

        ''' <summary>
        ''' Timer Elapsed event callback.
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        ''' <remarks>
        ''' Unsubscribe if the _timer runs out.
        ''' </remarks>
        Private Sub timer_Elapsed(ByVal sender As Object, ByVal e As Timers.ElapsedEventArgs)
            SyncLock _syncLock
                _unsubscribe = True

                ' Close the _timer.
                If _timer IsNot Nothing Then
                    _timer.Close()
                End If
            End SyncLock
        End Sub

        Private Sub OnTimedEvent(ByVal stateInfo As Object)
            Try
                SyncLock _pollingTimerSyncLock
                    ' Disable the timer to avoid cascading events.
                    _pollingTimer.Change(Threading.Timeout.Infinite, _pollingIntervalInMilliseconds)
                End SyncLock

                Dim autoSubscribeTimeoutThresholdInMinutes As Integer = Convert.ToInt32(ConfigurationManager.AppSettings("AutoSubscribeTimeoutThresholdInMinutes"))

                ' Verify the last time we got a status message was < "AutoSubscribeTimeoutThresholdInMinutes" minutes ago.
                Dim currentTime As Date = Date.Now
                ' first time or never subscribed, so in that case, we don't want to force a subscription until it is done at least once.
                If _lastStatusEventDateTime = Date.MinValue Then
                    Return

                ElseIf _lastStatusEventDateTime.AddMinutes(autoSubscribeTimeoutThresholdInMinutes) < currentTime Then ' Last status notification was more than "AutoSubscribeTimeoutThresholdInMinutes" minutes ago...
                    ' Renew the subscription.
                    Try
                        Dim subscriptionId As String = Subscribe()
                        WriteEventToLog(String.Format(SUBSCRIPTION_RENEWAL_TEMPLATE, Date.Now.ToShortDateString(), Date.Now.ToLongTimeString(), autoSubscribeTimeoutThresholdInMinutes, subscriptionId))
                    Catch ex As SoapException
                        WriteEventToLog(String.Format(SUBSCRIPTION_RENEWAL_ERROR_TEMPLATE, ex.Message, ex.StackTrace))
                    End Try
                End If
            Catch ex As Exception
                WriteEventToLog(String.Format(TIMER_ERROR_TEMPLATE, ex.Message, ex.StackTrace))
            Finally
                SyncLock _pollingTimerSyncLock
                    _pollingTimer.Change(_pollingIntervalInMilliseconds, _pollingIntervalInMilliseconds) ' re-enable the timer.
                End SyncLock
            End Try
        End Sub

#End Region

#Region "Static Helper Methods"

        ''' <summary>
        ''' Access event information for moved or copied events.
        ''' </summary>
        ''' <param name="mcet">The event details for a moved or copied event.</param>
        Private Shared Sub AccessMovedCopiedEvent(ByVal mcet As MovedCopiedEventType)
            ' Get the watermark for the event.
            Dim watermark As String = mcet.Watermark

            ' Get the timestamp for the event.
            Dim timestamp As Date = mcet.TimeStamp

            ' Get the old parent folder identifier.
            Dim oldParentFolder As FolderIdType = mcet.OldParentFolderId

            ' Get the new parent folder identifier.
            Dim newParentFolder As FolderIdType = mcet.ParentFolderId

            ' Get either the old folder identifier for a moved/copied folder
            ' or the old item identifier for a moved/copid item.
            If TypeOf mcet.Item1 Is ItemIdType Then
                ' Get the old item identifier of the item.
                Dim oldItemId As ItemIdType = TryCast(mcet.Item1, ItemIdType)
            Else
                ' Get the old folder identifier of the folder.
                Dim oldFolderId As FolderIdType = TryCast(mcet.Item1, FolderIdType)
            End If

            ' Get either the new folder identifier for a moved/copied folder
            ' or the new item identifier fir a moved/copied item.
            If TypeOf mcet.Item Is ItemIdType Then
                ' Get the new item identifier of the item.
                Dim newItemId As ItemIdType = TryCast(mcet.Item, ItemIdType)
            Else
                ' Get the new folder identifier of the folder.
                Dim newFolderId As FolderIdType = TryCast(mcet.Item, FolderIdType)
            End If
        End Sub

        ''' <summary>
        ''' Access event information for create, delete, or new mail events.
        ''' </summary>
        ''' <param name="bocet">The event details for a create, delete or new email event.</param>
        Private Shared Sub AccessCreateDeleteNewMailEvent(ByVal bocet As BaseObjectChangedEventType)
            ' Get the watermark for the event.
            Dim watermark As String = bocet.Watermark

            ' Get the timestamp for the event.
            Dim timestamp As Date = bocet.TimeStamp

            ' Get the parent folder identifier.
            Dim parentFolderId As FolderIdType = bocet.ParentFolderId

            ' Get either the folder or item identifier for a 
            ' create/delete/new mail event.
            If TypeOf bocet.Item Is ItemIdType Then
                ' Get the item identifier.
                Dim itemId As ItemIdType = TryCast(bocet.Item, ItemIdType)

                '
                ' Get the message using the ItemIdType.
                '

                ' From web.config
                Dim ewsServiceUrl As String = ConfigurationManager.AppSettings("EWSServiceUrl")

                Dim esb As New ExchangeService(ExchangeVersion.Exchange2010)
                esb.Url = New Uri(ewsServiceUrl)
                ' From web service's app pool identity.
                esb.UseDefaultCredentials = True

                Dim message As EmailMessage = EmailMessage.Bind(esb, New ItemId(itemId.Id))
                ConvertEmailToRequestItem(message)
            Else
                ' Get the folder identifier.
                Dim folderId As FolderIdType = TryCast(bocet.Item, FolderIdType)
            End If
        End Sub

        ''' <summary>
        ''' Access event information for modified events.
        ''' </summary>
        ''' <param name="met">The event details for a modified event.</param>
        Private Shared Sub AccessModifiedEvent(ByVal met As ModifiedEventType)
            ' Get the watermark for the event.
            Dim watermark As String = met.Watermark

            ' Get the timestamp for the event.
            Dim timestamp As Date = met.TimeStamp

            ' Get the parent folder identifier.
            Dim parentFolderId As FolderIdType = met.ParentFolderId

            ' Get either the folder or item identifier for the
            ' modified folder or item.
            If TypeOf met.Item Is FolderIdType Then
                ' Check if the folder has an unread count.
                If met.UnreadCountSpecified Then
                    Dim unreadCount As Integer = met.UnreadCount
                End If

                ' Get the folder identifier.
                Dim folderId As FolderIdType = TryCast(met.Item, FolderIdType)
            Else
                ' Get the item identifier.
                Dim itemId As ItemIdType = TryCast(met.Item, ItemIdType)
            End If
        End Sub

        ''' <summary>
        ''' Converts a new email message into a Request work item in TFS.
        ''' </summary>
        ''' <param name="message">An instance of EmailMessage containing the mail message details.</param>
        Private Shared Sub ConvertEmailToRequestItem(ByVal message As EmailMessage)
            Try
                ' TFS customizations.
                TfsConnection.ApplicationName = String.Format(TFS_APPLICATIONNAME_TEMPLATE, WindowsIdentity.GetCurrent().Name)
                TfsConnection.ClientSettingsDirectory = TfsClientCacheDirectory

                ' A conversation index is 22 bytes in length for the first email in the thread
                ' An additional 5-bytes are added for each email in the thread.
                Dim isFirstEmailInThread As Boolean = message.ConversationIndex.Length = 22

                Dim conversationIndex As String = Convert.ToBase64String(message.ConversationIndex)
                Dim latestConversationIndex As String = conversationIndex
                Dim conversationTopic As String = message.ConversationTopic
                Dim internetMessageId As String = message.InternetMessageId

                Dim title = message.Subject
                Dim [from] = message.From

                ' First check if prefix-based filtering is turned on, and if so, if the email subject line matches
                ' the defined prefix.
                Dim subjectPrefix As String = ConfigurationManager.AppSettings("SubjectPrefix")
                If Not String.IsNullOrWhiteSpace(subjectPrefix) Then
                    If Not title.StartsWith(subjectPrefix, StringComparison.InvariantCultureIgnoreCase) Then
                        WriteEventToLog(String.Format(SUBJECT_DOES_NOT_MATCH_PREFIX_TEMPLATE, subjectPrefix, title))

                        Return
                    End If
                End If

                ' Check if there is already a work item with the same internal message id.
                ' Since this identifier is unique to each message, if we find it already associated with a work
                ' item, then this is typically an indication that there are multiple subscriptions associated with
                ' the web service (possibly unintentionally since the subscription can be triggered multiple times)
                Dim isAlreadyAssigned As Boolean = IsEmailAlreadyConvertedToWorkItem(internetMessageId)
                If isAlreadyAssigned Then
                    WriteEventToLog(String.Format(ALREADY_ASSIGNED_EMAIL_SKIPPED_TEMPLATE, [from], message.ConversationIndex.Length, conversationTopic))

                    Return
                End If

                If Not isFirstEmailInThread Then
                    ' Try and find the base work item so we can append thread to it.
                    Dim baseConversationIndex() As Byte = message.ConversationIndex.Subset(0, 22)
                    Dim baseConversationIndexEncoded As String = Convert.ToBase64String(baseConversationIndex)

                    Dim workItemId As Integer = GetWorkItemByConversation(baseConversationIndexEncoded)
                    If workItemId > 0 Then
                        ' Update the work item with the body section unique to this part of the conversation/thread.
                        ' If Exchange cannot figure out the unique body, revert to saving the full body...
                        Dim partialBody As String = String.Format(WORKITEM_PARTIAL_BODY_TEMPLATE, [from].Name, [from].Address, String.Format("{0} {1}", message.DateTimeReceived.ToLongDateString(), message.DateTimeReceived.ToLongTimeString()), If(message.UniqueBody IsNot Nothing, message.UniqueBody.Text, message.Body.Text), ConfigurationManager.AppSettings("EmailThreadChildHeaderBGColor"))

                        UpdateWorkItem(workItemId, conversationIndex, partialBody) ' Store the latest conversation index

                        Return
                    Else
                        ' Since we can't find an existing base work item to which we can append this thread, we can
                        ' create a new base work item from this one.
                        ' This is typically the case when there are existing threads that have started before this
                        ' system was put in use.

                        If Convert.ToBoolean(ConfigurationManager.AppSettings("CreateNewWorkItemFromExistingThreadWithNoBase")) Then
                            ' Store the extracted base conversation index.
                            conversationIndex = baseConversationIndexEncoded
                            title = conversationTopic ' this removes any RE: and FW: prefixing the email subject.

                            WriteEventToLog(String.Format(NEW_EMAIL_FROM_EXISTING_THREAD_TEMPLATE, [from], message.ConversationIndex.Length, conversationTopic))
                        Else
                            ' Skip and return. Mention it in the log.
                            WriteEventToLog(String.Format(NEW_EMAIL_SKIPPED_TEMPLATE, [from], message.ConversationIndex.Length, conversationTopic))

                            Return
                        End If
                    End If
                End If

                Dim body = String.Format(WORKITEM_BODY_TEMPLATE, [from].Name, [from].Address, String.Format("{0} {1}", message.DateTimeReceived.ToLongDateString(), message.DateTimeReceived.ToLongTimeString()), title, message.Body.Text, conversationTopic, message.ConversationIndex.Length, conversationIndex, ConfigurationManager.AppSettings("EmailThreadParentHeaderBGColor"))

                ' NOTE: The creation logic utilizes an MSBuild task called CreateNewWorkItem to perform the creation.
                '       Since this code is used outside of any MSBuild scripts, the only thing needed in order
                '       to be able to utilize this common task is to pass it a mock IBuildEngine class.
                '       This was done for two reasons:
                '       1- To utilize an existing task class that is well tested.
                '       2- To demonstrate a way of calling and leveraging existing libraries without having to 
                '          rewrite the code to adapt it to a different hosting environment.
                '       The same was done for the update functionality.

                ' Create the work item from the email.
                Dim newWorkItem As New CreateNewWorkItem()
                newWorkItem.BuildEngine = New BuildEngine()

                newWorkItem.WorkItemTeamProject = ConfigurationManager.AppSettings("WorkItemTeamProject")
                newWorkItem.TeamFoundationServerUrl = ConfigurationManager.AppSettings("TeamFoundationServerUrl")
                newWorkItem.AssociatedWorkItems = ConfigurationManager.AppSettings("AssociatedWorkItems")
                newWorkItem.Title = title
                newWorkItem.Description = body
                newWorkItem.WorkItemType = ConfigurationManager.AppSettings("WorkItemType")
                newWorkItem.WorkItemFieldValues = String.Format(WORKITEM_FIELDS_TEMPLATE, internetMessageId, [from].Name, conversationTopic, conversationIndex, WORKITEM_DESCRIPTION_TEMPLATE, latestConversationIndex, ConfigurationManager.AppSettings("RequestSupportTeamName"))

                Dim result As Boolean = newWorkItem.Execute()
                If result Then
                    WriteEventToLog(String.Format(NEW_WORKITEM_CREATED_TEMPLATE, newWorkItem.WorkItemId, [from]))
                End If
            Catch ex As Exception
                WriteEventToLog(String.Format(EMAIL_TO_WORKITEM_ERROR_TEMPLATE, ex.Message, ex.StackTrace))
            End Try
        End Sub

        ''' <summary>
        ''' Determines whether the email message has already been written to a work item.
        ''' </summary>
        ''' <param name="internetMessageId">The Internet Message Id that uniquely identifies any Exchange email message.</param>
        ''' <returns>true if the message has already been written to a work item, false otherwise.</returns>
        Public Shared Function IsEmailAlreadyConvertedToWorkItem(ByVal internetMessageId As String) As Boolean
            ' Query TFS to get the work item id with the specified Internet Message Id.
            Dim wiql As String = String.Format(QUERY_BY_UNIQUE_IDENTIFIER_WIQL, ConfigurationManager.AppSettings("WorkItemTeamProject"), internetMessageId)

            Dim workItems As WorkItemCollection = GetWorkItemByCustomQuery(wiql)

            Dim isAlreadyConverted As Boolean = (workItems IsNot Nothing AndAlso workItems.Count > 0)
            If isAlreadyConverted Then
                WriteEventToLog(String.Format(EMAIL_ALREADY_CONVERTED_TO_WORKITEM_TEMPLATE, workItems(0).Id, internetMessageId))
            End If

            Return isAlreadyConverted
        End Function

        ''' <summary>
        ''' Gets a work item with the base conversation index specified.
        ''' </summary>
        ''' <param name="baseConversationIndex">The base conversation id (first 22 bytes in a conversation index byte array).</param>
        ''' <returns>The id of the work item if found, otherwise 0.</returns>
        Private Shared Function GetWorkItemByConversation(ByVal baseConversationIndex As String) As Integer
            ' Query TFS to get the work item id corresponding to the base conversation index.
            Dim wiql As String = String.Format(QUERY_BY_CONVERSATION_INDEX_WIQL, ConfigurationManager.AppSettings("WorkItemTeamProject"), baseConversationIndex)

            Dim workItems As WorkItemCollection = GetWorkItemByCustomQuery(wiql)

            If workItems IsNot Nothing AndAlso workItems.Count > 0 Then
                ' Pick the first work item in the collection; since the query sorts by Id descending, that would be the most recent work item.
                Return workItems(0).Id
            Else
                Return 0
            End If
        End Function

        ''' <summary>
        ''' Executes a WIQL query and returns the resulting work items collection.
        ''' </summary>
        ''' <param name="wiql">The WIQL query to be executed.</param>
        ''' <returns>The resulting WorkItemCollection instance.</returns>
        Public Shared Function GetWorkItemByCustomQuery(ByVal wiql As String) As WorkItemCollection
            Dim tfs As TfsTeamProjectCollection = TfsTeamProjectCollectionFactory.GetTeamProjectCollection(New Uri(ConfigurationManager.AppSettings("TeamFoundationServerUrl")))
            Dim workItemStore As WorkItemStore = CType(tfs.GetService(GetType(WorkItemStore)), WorkItemStore)
            Return workItemStore.Query(wiql)
        End Function

        ''' <summary>
        ''' Updates a work item with the part of the email body that is unique to the current email in a threaded email conversation.
        ''' </summary>
        ''' <param name="workItemId">The id of the work item to be updated.</param>
        ''' <param name="conversationIndex">The current value of the conversation id.</param>
        ''' <param name="uniqueBodyText">The part of the email body that is unique to the current email.</param>
        Private Shared Sub UpdateWorkItem(ByVal workItemId As Integer, ByVal conversationIndex As String, ByVal uniqueBodyText As String)
            Try
                ' NOTE: The update logic utilizes an MSBuild task called UpdateWorkItem to perform the update.
                '       Since this code is used outside of any MSBuild scripts, the only thing needed in order
                '       to be able to utilize this common task is to pass it a mock IBuildEngine class.
                '       This was done for two reasons:
                '       1- To utilize an existing task class that is well tested.
                '       2- To demonstrate a way of calling and leveraging existing libraries without having to 
                '          rewrite the code to adapt it to a different hosting environment.
                '       The same was done for the creation functionality.

                ' Update the work item with the latest conversation index and the text of the email thread
                '       that is unique to this last message.
                Dim existingWorkItem As New UpdateWorkItem()
                existingWorkItem.BuildEngine = New BuildEngine()

                existingWorkItem.WorkItemTeamProject = ConfigurationManager.AppSettings("WorkItemTeamProject")
                existingWorkItem.TeamFoundationServerUrl = ConfigurationManager.AppSettings("TeamFoundationServerUrl")
                existingWorkItem.AssociatedWorkItems = ConfigurationManager.AppSettings("AssociatedWorkItems")
                existingWorkItem.WorkItemFieldValues = String.Format(UPDATE_WORKITEM_FIELDS_TEMPLATE, conversationIndex)
                existingWorkItem.WorkItemId = workItemId
                existingWorkItem.History = uniqueBodyText

                Dim result As Boolean = existingWorkItem.Execute()
                If result Then
                    WriteEventToLog(String.Format(WORKITEM_UPDATED_TEMPLATE, workItemId, conversationIndex))
                End If
            Catch ex As Exception
                WriteEventToLog(String.Format(UPDATEWORKITEM_ERROR_TEMPLATE, ex.Message, ex.StackTrace))
            End Try
        End Sub

        ''' <summary>
        ''' Writes an entry into the events log file.
        ''' </summary>
        ''' <param name="message">The status message to be logged.</param>
        Friend Shared Sub WriteEventToLog(ByVal message As String)
            Dim filename As String = String.Format(NOTIFICATION_EVENTS_LOG_TEMPLATE, _baseLogFolder)
            Dim archivalThresholdInBytes As Integer = Convert.ToInt32(ConfigurationManager.AppSettings("ArchivalThresholdInKBytes")) * 1024

            ' Do we need to create a new file and rename the old one?
            If File.Exists(filename) Then
                Dim fileInfo As New FileInfo(filename)
                If fileInfo.Length > archivalThresholdInBytes Then
                    ' Time to archive.
                    Dim timestamp As String = PushSubscriber.PushNotificationSubscriber.GetTimestamp()
                    RetryManager.InvokeWithRetries(Sub()
                                                       fileInfo.MoveTo(String.Format("{0}-{1}.txt", filename.Substring(0, filename.Length - 4), timestamp))
                                                   End Sub
                                                   )

                    ' Do we need to cleanup?
                    Dim numberOfArchivesToKeep As Integer = Convert.ToInt32(ConfigurationManager.AppSettings("NumberOfArchivesToKeep"))
                    Dim files() As String = Directory.GetFiles(Directory.GetParent(filename).FullName, "SubscriberEventLog*", SearchOption.TopDirectoryOnly)

                    If files.Count() > numberOfArchivesToKeep Then
                        ' Sort by newest first
                        Dim sortedFiles = From file In files
                                          Order By New FileInfo(file).LastWriteTime Descending
                                          Select file
                        Dim counter As Integer = 0
                        For Each file In sortedFiles
                            If counter >= numberOfArchivesToKeep Then
                                ' Delete old archived file.
                                RetryManager.InvokeWithRetries(Sub()
                                                                   Dim fileVar = New FileInfo(file)
                                                                   fileVar.Delete()
                                                               End Sub)
                            End If
                            counter += 1
                        Next file
                    End If
                End If
            End If
            Using sw As New StreamWriter(filename, True)
                sw.WriteLine(message)
            End Using
        End Sub

        ''' <summary>
        ''' Persists the SendNotificationResponseMessageType message to an XML file.
        ''' </summary>
        ''' <param name="response"></param>
        ''' <param name="timestamp">A timestamp string (formatted datetime value).</param>
        Public Shared Sub CreateXmlMessageTextFile(ByVal response As SendNotificationResponseMessageType, ByVal timestamp As String)
            ' Create a text file with the notification XML.
            Using myRespWriter As New StreamWriter(String.Format(NOTIFICATION_RESPONSE_MESSAGES_LOG_TEMPLATE, _baseLogFolder, response.GetType().Name, timestamp))
                Dim mySerializer As New XmlSerializer(response.GetType())
                mySerializer.Serialize(myRespWriter, response)
            End Using
        End Sub

#End Region

        Private Shared Function PushSubscriber() As Object
            Throw New NotImplementedException
        End Function

    End Class
End Namespace
